#include <stdio.h>
#include <fcntl.h>
#include "sysdep.h"

int fixed=0;

void gop2time(unsigned char* gop, unsigned char* time) {

  time[0]=(gop[0]&(64+32+16+8+4))>>2;
  time[1]=((gop[0]&(2+1))<<4)
    +((gop[1]&(128+64+32+16))>>4);
  time[2]=((gop[1]&(4+2+1))<<3)
    +((gop[2]&(128+64+32))>>5);
  time[3]=((gop[2]&(16+8+4+2+1))<<1)
    +((gop[3]&(128))>>7);
}

void printtime(unsigned char* time) {
  printf("%2.2d:%2.2d:%2.2d.%2.2d\r",time[0],time[1],time[2],time[3]);
}

void time2gop(unsigned char* gop, unsigned char* time) {

  gop[0] = (gop[0]&128)+             // 7
    (time[0]<<2)+                    // 6-2
    ((time[1]&(32+16))>>4);          // 1-0
  gop[1] = ((time[1]&(8+4+2+1))<<4)+ // 7-4
    (gop[1]&8)+                      // 3
    ((time[2]&(32+16+8))>>3);        // 2-0
  gop[2] = ((time[2]&(4+2+1))<<5)+
    ((time[3]&(32+16+8+4+2))>>1);
  gop[3] = ((time[3]&1)<<7)+
    (gop[3]&(64+32+16+8+4+2+1));
}

void frame2time(int frame, unsigned char* time) {
  time[3] = frame%30;
  time[2] = (frame/30)%60;
  time[1] = ((frame/30)/60)%60;
  time[0] = ((frame/30)/60)/60;
}

int goptime(int fd, int i){
  unsigned char buf[4];
  unsigned char oldtime[4]; // h,m,s,f
  unsigned char newtime[4]; // h,m,s,f
  read(fd,buf,4);

  gop2time(buf,oldtime);
  frame2time(i,newtime);

  if (memcmp(oldtime,newtime,4) != 0) {
    fixed++;
    printf(" Fixing ");
    time2gop(buf,newtime);
    lseek(fd,-4,SEEK_CUR);
    write(fd,buf,4);
  }

  printtime(newtime);
  fflush(stdout);
}

int main(int argc, char ** argv) {
  int fd;
  unsigned char a,b,c,d,e;
  int x;
  int fi;
  unsigned char zero=0;
  unsigned char one=0x01;
  unsigned char b7=0xb7;
  OFF_T eofpos;

  for (fi=1; fi<argc; fi++) {
    fd = open_rw(argv[fi]);
    if (!fd) {
      printf("Couldn't open file %s\n",argv[fi]);
      return(-1);
    }
    a=-1,b=-1,c=-1,d=0,x=0,eofpos=-1;
    while (read(fd,&e,1)==1) {
      a = b;
      b = c;
      c = d;
      d = e;
    
      if ((a==0) &&
	  (b==0) &&
	  (c==1))
	{
	  if (d==0) { // Picture
	    x++;
	  }
	  if (d==0xb7) { // End of sequence. Replace by zero-padding.
#ifdef DEBUG
	    printf("End of sequence\n");
#endif
	    eofpos=lseek(fd,-2,SEEK_CUR);
	    write(fd,&zero,1);
	    write(fd,&zero,1);
	  }
	  if (d==0xb8) { // GOP
	    printf("%s ",argv[fi]);
	    goptime(fd,x);
	  }
	}
    }
    if (eofpos>0) {
      lseek(fd,eofpos,SEEK_SET);
      write(fd,&one,1);
      write(fd,&b7,1);
    }
    printf("\nfinished %s \n",argv[fi]);
    printf("fixed %d GOP timestamps\n",fixed);
    fixed=0;
    close(fd);
  }
  return 0;
}
